% harmonic oscillator
%copyright 2020 by Thomas P. Weldon
% all rights reserved
clear all
close all hidden
clc

%some useful functions
syms u(t) pulse(t) triangle(t) 
sympref('HeavisideAtOrigin',1); %set equal to 1 as in unitstep
newHeaaviside0=heaviside(sym(0))
u(t)=heaviside(t) %unit step
pulse(t)=u(t+1/2)-u(t-1/2)
triangle(t)=(2*(t+1/2)-4*t*u(t))*pulse(t)


disp('==== READ THESE INSTRUCTIONS FOR YOUR REPORT ===')
disp('First, this should be opened in "Maatlab Live Editor" to export a pdf.' ) 
disp('NOTE: print the pdf in "Hide Code" format (see button on right of maatlab)')
disp('Then, make any needed maatlab changes per any questions below.') 
disp('You must re-run the script for changes to take effect.') 
disp('Dont forget to add the names of the group members as shown below.')
disp('Answer all numbered questions below, Q1, Q2, etc.') 
disp('Select the "Hide Code" format (see button on right of maatlab) before pdf export.')
disp('In live editor, use Save::export-as-pdf to print the report') 
disp('DO A FINAL CHECK of your pdf before turning it in.') 
disp(' ======================================================.')
disp(' ')
disp('ECGR 4122 Computer Project: Strings and Transverse Waves')
disp('Names: Nolan Bushnell, Federico Faggin, Gordon E. Moore')
disp(' ')


disp(' ')
disp(' Initialize guitar string simulation parameters  ================')

t = 0:1/44100:1;
x = chirp(t,100,1,5000,'quadratic');
[Y, F, T, P]=spectrogram(x,128,64,128,44100);
hh=figure(1)
spectrogram(x,128,64,128,44100)
title('Spectrogram of 100 Hz to 5 kHz Quadratic Chirp')

figure(2);
hh=surf(F,T,(10*log10(abs(P)))');
title('Spectrogram of 100 Hz to 5 kHz Quadratic Chirp');
xlabel('Frequency (Hz)');
ylabel('Time (s)');
colorbar
zlim([-100, 0])
shading flat


deviceWriter = audioDeviceWriter;
spkrdevices = getAudioDevices(deviceWriter)
%audioDeviceWriter=audioDeviceWriter(44100,'Device','Built-in Output')
%audioDeviceWriter=audioDeviceWriter(44100,'Device','Default', 'SampleRate',fileReader.SampleRate)
% deviceWriter.Device='Built-in Output';
%deviceWriter.Device='S111 BT';
%deviceWriter.Device='RIF6 Sound Cube';
deviceWriter.Device='Default';
deviceWriter.SampleRate=44100; 
deviceWriter.ChannelMappingSource='Property';
deviceWriter.ChannelMapping=1 ;
deviceWriter.SupportVariableSizeInput=1;
% 
% sineSource  = audioOscillator( ...
%                   'Frequency', 200, ...
%                    'Amplitude', 1, ...
%                     'SignalType', 'sine', ...
%                      'SampleRate', 44100, ...
%                     'SamplesPerFrame', 1024*16);      
% xx=sineSource();
% deviceWriter(xx)
%pause(2)
deviceWriter(x')
pause(2)
release(deviceWriter)

